# iSCSI configuration file - see iscsi.conf(5)

# Authentication Settings
# -----------------------
# You may configure a default Username and Password to use for CHAP
# authentication by specifying the Global username and password parameters
# in the format as mentioned below. These entries will need to precede any
# "DiscoveryAddress" entries if authentication needs to be enabled for all the
# iSCSI targets.
#
# Example:
#
#Username=alice
#Password=nty57nbe
#      or
#OutgoingUsername=alice
#OutgoingPassword=nty57nbe  
#
# The "OutgoingUsername" will specify the username to be sent to the target
# for login authentication. The "OutgoingPassword" is the CHAP secret password
# to be used when sending challenge responses to the target.
# 
# You may configure CHAP authentication settings that will apply to every
# target discovered at a particular address by adding "OutgoingUsername=u"
# and "OutgoingPassword=p" entries indented below the "DiscoveryAddress" 
# entry they apply to.
#
# Example:
#
#DiscoveryAddress=192.168.10.94
#     OutgoingUsername=alice
#     OutgoingPassword=nty57nbe 
#             
#             or 
#
#DiscoveryAddress=192.168.10.94
#     Username=alice
#     Password=nty57nbe 
#
# You can configure 2 WAY authentication to enable the authentication of the
# initiator by the target and vice-versa. The "OutgoingUsername" and "Outgoing
# Password" fields specify the initiator authentication and "IncomingUsername"
# and "IncomingPassword" can be used for target authentication.
#
# The "IncomingUsername" will specify the username that must be received from
# target if login authentication occurs. The "IncomingPassword" is the CHAP
# secret to be used when verifying challenge responses from the target.
# The "OutgoingPassword" and "IncomingPassword"  fields should be unique.
#
# Example:
#
#OutgoingUsername=alice
#OutgoingPassword=nty57nbe
#
#IncomingUsername=alice3
#IncomingPassword=nty57nbe3


# CRC Settings
# ------------
# You may configure CRC32C digest checking for Header and Data part of
# iSCSI PDUs. To enable the CRC32C checking you can specify 
# "HeaderDigest=Always". "HeaderDigest=Never" will disable the CRC32C digest
# checking for the ISCSI Headers. You can specify the preference for the 
# HeaderDigest values by putting "HeaderDigest=Prefer-On" or 
# "HeaderDigest=Prefer-Off". In these cases the driver will take the values 
# offered by the target during the text key negotiation. The same logic holds 
# for DataDigest key.
#
#HeaderDigest=Always
#HeaderDigest=Never
#HeaderDigest=Prefer-on
#HeaderDigest=Prefer-off
#
#DataDigest=Always
#DataDigest=Never
#DataDigest=Prefer-on
#DataDigest=Prefer-off
#
# The CRC Settings can be configured for a particular target in the following
# format.
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  HeaderDigest=always
#  DataDigest=always


# Portal Failover Settings
# ------------------------
# You may configure the driver to connect to the target through alternate  
# IP addresses automatically whenever connection to the target is lost.
# This feature can be enabled by specifying "PortalFailover=yes". The valid
# values for "PortalFailover" key can be either "yes or "no". By default
# this feature is kept on.
#
#PortalFailover=yes
#PortalFailover=no
#
# You can specify the Portal failover settings per target as below.
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  PortalFailover=yes
#
# You can specify a Preferred Subnet or Preferred Portal to which the iSCSI
# driver should connect to when the driver is started or whenever portal
# failover occurs. The valid value for PreferredSubnet will be the subnet
# address along with the netmask value. The iSCSI Driver will try to failover
# to the portal in the specified subnet. The PreferredPortal will take the IP
# address of the portal to which the target connections will be failed over.
#
# If both PreferredSubnet and PreferredPortal values are specified, then
# PreferredPortal will take precedence.
#
#PreferredSubnet=192.168.10.0/24
#
#PreferredPortal=192.168.10.95
#
# The above parameters can be configured per target as mentioned in the format
# below.
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  PreferredSubnet=192.168.10.0/24


# Multipath Settings
# ------------------
# You may configure the driver for multipathing, where 2 or more network paths
# are available to the same target. This feature can be enabled by specifying
# "Multipath=Portal". The valid values for "Multipath" can be "no" or "portal"
# or "portalgroup".
#
#Multipath=no
#Multipath=portal
#Multipath=portalgroup
#
# Multipathing can be configured per target as mentioned in the format below.
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  Multipath=portal


# LUN Settings
# ------------
# The LUN settings can be specified per TargetName or for all the targets
# whose TargetNames are mentioned in the configuration file. If no TargetName
# is present in the configuration file, the lun(s) will be configured for
# all the available iSCSI targets.
# The LUN settings can be specified in the following 3 formats:-
# LUN=<lun_number>
# LUNs=<lun_range>
# LUNs=<lun_list>
#
# The range of luns to be configured can be specified using a hyphen. A comma
# separated list of luns can also be used.
# Example:
#
#LUN=35
#LUNs=39-47
#LUNs=200,49,0,31
#
# LUNs can be configured per TargetName as mentioned in the format below.
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  LUNs=39-47


# Connection Timeout Settings
# --------------------------- 
# Connection Timeout can  be specified per DiscoveryAddress, per TargetName
# or per Subnet configuration.
#
# All the timeout parameters take the value in seconds.
#
# LoginTimeout can be configured to specify the time to wait for a login
# PDU to be sent or received before failing the login on a particular
# connection due to a login failure. 
#
#LoginTimeout=15
#
# AuthTimeout can be configured to specify the time to wait for a login
# PDU carrying Authentication info to be sent or received before failing the
# login on a particular connection due to authentication failure.
#
#AuthTimeout=45
#
# IdleTimeout setting can be used to specify the length of time a connection
# may remain idle not expecting a response from the target and before checking
# the connection with a ping.
#
#IdleTimeout=60
#
# PingTimeout is the length of time to wait for a ping response before assuming
# the connection is dead and replacing it with a new one.
#
#PingTimeout=5


# Session Timeout Settings
# ------------------------
# These timeout settings are valid per session. They can be configured as
# global or per Target Configuration.
#
# ConnFailTimeout will specify the length of time to wait for session
# re-establishment before failing out commands to a target device. If the value
# is set to 0 i.e, the default value, then there is no timeout. If Multipath is
# enabled, then you can set ConnFailTimeout to a small value such as 10 or 30.
# In other cases the default value can be retained.
# 
#ConnFailTimeout=0
#
# MinDiskCommandTimeout will specify the minimum length of time to wait before
# failing commands to a target device. The default value is -1, which disables
# the command timeout, allowing commands to  be retried forever.
#
#MinDiskCommandTimeout=-1
#
# MaxDiskCommandTimeout will specify the maximum length of time to wait before
# failing SCSI commands to a target device.
# If multipath is enabled, the MaxDiskCommandTimeout can be set to a smaller
# value, say 5 or 10 seconds to initiate faster command timeout.
#
#MaxDiskCommandTimeout=0


# Error Handling Timeout settings
# -------------------------------
# Error handling timeout can  be specified per TargetName or per Subnet
# configuration.
#
# All the timeout parameters take the value in seconds.
#
# You may want to configure AbortTimeout to specify the length of time to
# wait for an abort to complete before assuming the abort has failed. 
#
#AbortTimeout=10
#
# You can configure ResetTimeout to specify the length of time to wait for
# a reset to complete before assuming the reset has failed.
#
#ResetTimeout=30


# Continuous Discovery settings
# -----------------------------
# You can configure discovery session to be kept open by setting
# "Continuous" key to "yes" (default setting). Set Continuous=no to close
# the discovery session, once the discovery is over.
#
#Continuous=yes
Continuous=no
#
# This parameter can be specified per DiscoveryAddress configuration.
#
#DiscoveryAddress=10.77.13.52
#  Continuous=yes


# AsyncEvent Notification Settings
# -------------------------------
# You can configure to receive vendor specific async events from
# the target by setting "SendAsyncText" key. The valid values can be either
# "yes" or "no". If set to "yes" target notifies the async events to the
# initiator. If set to "no" target does not send any async events.
#
#SendAsyncText=yes
#SendAsyncText=no
#
# The SendAsyncText key can be specified for a particular Discovery Address.
#
#DiscoveryAddress=10.77.13.52
#  SendAsyncText=yes


# iSCSI Operational Parameter settings
# ------------------------------------
# The settings can be specified globally which will apply across all target
# connections or can be specified per target configuration.
#
# InitialR2T takes a boolean value. When negotiated to "no", the initiator has
# an implied initial R2T for FirstBurstLength at offset 0. When set to "yes"
# the initiator must wait for an R2T before sending any data.
#
#InitialR2T=yes
#InitialR2T=no
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  InitialR2T=yes
#
# ImmediateData takes a boolean value. When negotiated to "no", the initiator
# does not send unsolicited data along with the iSCSI command PDU. When set to
# "yes" the initiator sends unsolicited data with the iSCSI command packet.
#
#ImmediateData=yes
#ImmediateData=no
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  ImmediateData=yes
#
# MaxRecvDataSegmentLength specifies the maximum number of bytes of data the
# initiator or target can receive in a iSCSI PDU. The value can be specified
# between the range 512-(2^24-1).
#
#MaxRecvDataSegmentLength=128 * 1024
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  MaxRecvDataSegmentLength=128 * 1024
#
# FirstBurstLength specifies the number of bytes of unsolicited data the
# initiator is allowed to send. The value can range between 512-( 2^24-1) bytes.
#
#FirstBurstLength=262144
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  FirstBurstLength=262144
#
# MaxBurstLength specifies the maximum SCSI payload that an initiator and
# target can negotiate for. The value can range between 512-(2^24-1) bytes. 
#
#MaxBurstLength=(16 * 1024 * 1024) - 1024
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  MaxBurstLength=(16 * 1024 * 1024) - 1024
#
# TCPWindowSize specifies the maximum amount of data that can be sent or
# received on the TCP connection before receiving an acknowledgement.
# This parameter can also be specified for TargetName and Subnet Configutaion.
#
#TCPWindowSize=262144
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  TCPWindowSize=262144
#
#Subnet=10.77.13.0/16
#  TCPWindowSize=262144


# Configuration parameters can be specified w.r.t DiscoveryAddress,
# TargetIPAddress, Subnet or TargetName.
#
# Subnet Specific Settings
# ------------------------
# Subnet Settings apply to sessions to a network portal in one of the
# specified subnets, or whose address matches one of the specified addresses.
# Multiple subnets and address may be specified, seperated by commas. Subnet
# takes the "address" and "netmask" values in the format as specified below.
#
#Subnet=10.4.100.0/24
#
# Alternately Address can also be used to specify the Subnet values in the
# format a.b.c.d/32
#
#Address=10.4.100.0
# 
# The Subnet Settings can have the following entries specific to a Subnet.
#
# 1) Connection Timeout Settings
# 2) Error Handling Timeout Settings
# 3) TCP Settings


# DiscoveryAddress Settings
# -------------------------
# Add "DiscoveryAddress=xxx" entries for each iSCSI router instance.
# The driver will attempt to discover iSCSI targets at that address
# and make as many targets as possible available for use.
# 'xxx' can be an IP address or a hostname.  A TCP port number can be
# specified by appending a colon and the port number to the address. 
# All entries have to start in column one and must not contain any 
# whitespace.
#
# Example:
#
#DiscoveryAddress=scsirouter1
#DiscoveryAddress=192.168.10.95
#DiscoveryAddress=192.168.10.96:3260
#DiscoveryAddress=fas960-1.citi.umich.edu
DiscoveryAddress=10.4.0.2
#
# The DiscoveryAddress Settings can take following entry.
#
# 1) Authentication Settings
# 2) ConnectionTimeout Settings
# 3) Continuous Discovery settings
# 4) AsyncEvent Notification Settings


# SLP settings
# ------------
# The SLP settings enable the use of SLP discovery mechanism for discovering
# iSCSI targets. The SLP discovery mechanism can be used along with 
# DiscoveryAddress to discover the iSCSI targets.
#
# SLPUnicast can be used to configure discovery at the address specified in
# the SLPUnicast field. The valid value for SLPUnicast will be the IP Address
# at which the iSCSI targets can be discovered. 
#
#SLPUnicast=192.168.10.95
#
# SLPMulticast can be used to configure discovery over multicast. The valid 
# values are "all" or "none" or a list of IP addresses over which the targets  
# can be discovered. This list of addresses will specify the Network Interface
# addresses on the initiator side.
# 
#SLPMulticast=all
#SLPMulticast=none
#SLPMulticast=192.168.10.94,10.77.10.94
#
# You may configure CHAP authentication settings that will apply to every
# target discovered through SLP by adding "Username" or "OutgoingUsername"
# entries indented below the "SLPUnicast" and "SLPMulticast".
#
#SLPUnicast=192.168.10.95
#  Username=alice
#  Password=nty57nbe
#
#SLPMulticast=all
#  OutgoingUsername=alice1
#  OutgoingPassword=nty57ocf
#
# PollInterval indicates the time interval between SLP queries. The value can
# be specified either in seconds as "300s" or in minutes as "6m" or in hours
# as "6h". 
#
#PollInterval=300s


# TargetName Specific Settings
# ----------------------------
# Target-specific settings should be entered below the respective "TargetName"
# entries. If Multipath is enabled, then these target-specific settings will be
# be applicable for all iSCSI sessions to this target.
#
# If settings under "Subnet" entry are conflicting with settings under 
# "TargetName" entry, the settings under "Subnet" will be considered.
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
TargetName=iqn.1992-08.com.netapp:sn.50391891
#TargetIPAddress=141.211.133.16/32
TargetIPAddress=10.4.0.2/32
#
# The TargetName Settings can have the following entries specific to a target.
#
# 1) CRC Settings
# 2) iSCSI Operational Parameter settings
# 3) Connection Timeout Settings
# 4) Session Timeout Settings
# 5) Error Handling Timeout Settings
# 6) TCP Settings
# 7) Portal Failover Settings
# 8) Multipath Settings
# 9) LUN settings
# 10) PreferredSubnet and PreferredPortal Settings


# NOTES:
# ------
# If any of the configuration parameters are not mentioned under Configuration 
# type DiscoveryAddress, TargetName or Subnet, global values will be
# considered if they are specified, else default settings will apply for these
# configuration parameters.
# 
# All entries specified below any of the Configuration types must be indented
# by a whitespace character or a tab to be considered local to a category. If
# they are specified in the 1st column they are by default considered as global
# values.
#
# Example:
#
#Subnet=10.2.1.0/24
#   ActiveTimeout=10
#   PingTimeout=10
#LoginTimeout=30
# 
# In the above case LoginTimeout is considered a global value and will have
# scope until another LoginTimeout entry is specified. 

# If there are conflicting entries for the same target through the Subnet and
# TargetName or DiscoveryAddress entries, the Subnet entries in the file will
# take precedence.
#
# Example:
#
#Subnet=10.2.1.0/32
#  ActiveTimeout=10
#
#TargetName=iqn.1987-05.com.cisco:00.0d1d898e8d66.t0
#  ActiveTimeout=15
#
# In the above scenario, the Subnet specific setting will take effect.

# If there is any conflict between DiscoveryAddress and Global entries,
# DiscoveryAddress settings takes precedence.
#
# e.g:
#Username=bob
#Password=bob123
#
#DiscoveryAddress=10.2.1.20
#  Username=alice
#  Password=alice123
# 
# In the above case, the DiscoveryAddress settings will be considered.

# Targets without any matching Subnet, TargetName or DiscoveryAddress entries
# will take the global values if any in the config file, else the default
# values will take effect.
#
# Example:
#
#HeaderDigest=prefer-on
#DataDigest=prefer-on
#InitialR2T=No
#ActiveTimeout=10
#
# If there are any duplicate entries for a configuration parameter in the conf
# file the latest entry in the file will take effect.
#
# Example:
#
#IncomingUsername=alice
#IncomingPassword=alice123
#multipath=no
#LUNs=0-255
#IncomingUsername=bob
#IncomingPassword=bob123
#
# In the above case, IncomingUsername will be "bob" and IncomingPassword will
# be "bob123".
#
#
